<template>
  <el-table
    :data="tableData"
    style="width: 100%; margin-bottom: 20px"
    row-key="id"
    border
    :expand-row-keys="expandRow"
  >
    <el-table-column prop="name" label="โครงการ" sortable min-width="300">
    </el-table-column>
    <el-table-column prop="stargic.name" label="ยุทธศาสตร์" sortable min-width="150">
    </el-table-column>
    <el-table-column label="จัดการ" sortable width="150">
      <template v-slot="scope">
        <div class="flex justify-end">
          <button
            class="
              transition
              duration-200
              ease-in-out
              transform
              hover:-translate-y-1
              px-3
              py-1
              bg-gradient-to-r
              from-yellow-500
              to-yellow-300
              rounded-md
              text-white
              shadow-md
              focus:outline-none
            "
            @click="editBtn(scope.row)"
            v-if="scope.row.children.length <= 0"
          >
            อัพเดท
          </button>
          <div class="mx-1"></div>
          <button
            class="
              transition
              duration-200
              ease-in-out
              transform
              hover:-translate-y-1
              px-3
              py-1
              bg-gradient-to-r
              from-red-600
              to-red-400
              rounded-md
              text-white
              shadow-md
              focus:outline-none
            "
            @click="deleteProject(scope.row)"
          >
            ลบ
          </button>
        </div>
      </template>
    </el-table-column>
  </el-table>
</template>

<script>
import Swal from "sweetalert2";
import { Inertia } from "@inertiajs/inertia";

export default {
  props: {
    tableData: Array,
    expandRow: Array,
  },
  setup() {
    const deleteProject = async ({ id }) => {
      const { isConfirmed } = await Swal.fire({
        title: "คุณแน่ใจไหม?",
        text: "คุณจะไม่สามารถกู้ข้อมูลคืนได้!",
        icon: "warning",
        showCancelButton: true,
        confirmButtonColor: "#3085d6",
        cancelButtonColor: "#d33",
        confirmButtonText: "ใช่, ลบเลย!",
        cancelButtonText: "ยกเลิก!",
      });
      if (!isConfirmed) return false;
      Inertia.delete(route("admin.projects.destroy", { project: id }), {
        onError: (err) => {
          console.log(err);
        },
        onSuccess: () => {
          Toast.fire({
            icon: "success",
            title: "ลบข้อมูลโครงการสำเร็จ ",
          });
        },
      });
    };

    const editBtn = (row) => {
      console.log(row);
      Inertia.get(
        route("admin.projects.edit", {
          project: row.id,
          yearsId: row.budget_year_id,
          stargicId: row.stargic_id,
          mainId: row.parent?.parent_id || row.parent_id,
        })
      );
    };
    return {
      editBtn,
      deleteProject,
    };
  },
};
</script>

<style>
</style>
